package g55803.dev2.td1;

import java.util.Scanner;

/** Fournit une classe utilitaire pour les lectures du <code>Memory</code>.
 *
 * @author Nathan Furnal
 */

public class Lecture {

    /** Lit un entier entré par l'utilisateur, de manière robuste.
     * Demande une nouvelle saisie tant qu'un entier n'est pas entré.
     * @param message message à afficher à l'entrée.
     * @return l'entier saisi par l'utilisateur.
     */
    public static int readUserInt(String message){
        Scanner s = new Scanner(System.in);
        System.out.println(message);
        while(!s.hasNextInt()){
            s.next();
            System.out.println("Le nombre saisi n'est pas un entier.");
            System.out.println(message);
        }
        return s.nextInt();
    }

    /** Propose un nombre de pairs à jouer dans la limite acceptée
     * tant que l'utilisateur ne sélectionne pas une valeur correcte.
     * @return Le nombre de pairs à jouer.
     */
    public static int readNbrPairs(){
        int min = 3;
        int max = 20;
        int nbrPairs = readUserInt("Avec combien de paires voulez-vous jouer ? (3 à 20)");
        while (nbrPairs < min || nbrPairs > max){
            System.out.println("Sélectionnez un nombre valide de pairs !");
            nbrPairs = readUserInt("Avec combien de paires voulez-vous jouer ? (3 à 20)");
        }
        return nbrPairs;
    }
}
