package g55803.dev2.td3;
import java.util.Scanner;

/**
 * @author Nathan Furnal
 */
public class Memory {
    private Game game;

    public Memory(int n){
        game = new Game(n);
    }

    /** Lit un entier entré par l'utilisateur, de manière robuste.
     * Demande une nouvelle saisie tant qu'un entier n'est pas entré.
     * @param message message à afficher à l'entrée.
     * @return l'entier saisi par l'utilisateur.
     */
    public static int readUserInt(String message){
        Scanner s = new Scanner(System.in);
        System.out.println(message);
        while(!s.hasNextInt()){
            s.next();
            System.out.println("Le nombre saisi n'est pas un entier.");
            System.out.println(message);
        }
        return s.nextInt();
    }

    public int askPosition(){
        int minPos = 0;
        int maxPos = game.getSize() - 1;
        String message = "Entrez une position de carte (" + minPos + " à " + maxPos + ") :";
        int pos = readUserInt(message);
        while(pos < minPos || pos > maxPos || !game.isCardHidden(pos)){
            System.out.println("Cette carte n'est pas disponible !");
            pos = readUserInt(message);
        }
        System.out.println("La valeur de la carte est : " + game.getCardValue(pos));
        return pos;
    }

    public int playMemory(){
        int turns = 1;
        game.shuffle();
        while (!game.isGameOver()){
            System.out.println(game);
            int pos1 = askPosition();
            int pos2 = askPosition();
            game.checkPositions(pos1, pos2);
            turns++;
        }
        return turns;
    }

    /** Propose un nombre de pairs à jouer dans la limite acceptée
     * tant que l'utilisateur ne sélectionne pas une valeur correcte.
     * @return Le nombre de pairs à jouer.
     */
    public static int readNbrPairs(){
        int min = 3;
        int max = 20;
        int nbrPairs = readUserInt("Avec combien de paires voulez-vous jouer ? (3 à 20)");
        while (nbrPairs < min || nbrPairs > max){
            System.out.println("Sélectionnez un nombre valide de pairs !");
            nbrPairs = readUserInt("Avec combien de paires voulez-vous jouer ? (3 à 20)");
        }
        return nbrPairs;
    }


    public static void main(String[] args) {
        System.out.println("*** Memory, the game you'll remember \\ (•◡•) / ***");
        int nbrPairs = readNbrPairs();
        Memory mem = new Memory(nbrPairs);
        int turns = mem.playMemory();
        System.out.println("Bravo vous avez gagné !");
        System.out.println("Vous avez terminé en "+ turns + " tours!");
    }

}
