package g55803.dev2.td4;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Nathan Furnal
 */
public class Nombres {
    private List<Integer> nombres;

    /**
     * Constructeur de la classe Nombres.
     * Il instancie une ArrayList vide pour contenir des entiers.
     */
    public Nombres() {
        this.nombres = new ArrayList<>();
    }

    /**
     * Ajoute un élément en fin de liste.
     *
     * @param val La valeur à ajouter dans la liste.
     */
    public void add(Integer val) {
        nombres.add(val);
    }

    /**
     * Enlève un élément de la liste.
     *
     * @param val Élément à enlever.
     */
    public void remove(Integer val) {
        if (nombres.indexOf(val) > 0)
            nombres.remove(val);
    }

    /**
     * Somme les valeurs de la liste.
     *
     * @return Somme de la liste.
     */
    public Integer sum() {
        return TdListes.sum(nombres);
    }

    /**
     * Concatène la liste en paramètre en fin de la liste courante.
     *
     * @param other Autre liste.
     */
    public void concat(List<Integer> other) {
        for (Integer el : other)
            nombres.add(el);
    }

    /**
     * Trouve la valeur minimum de la liste.
     *
     * @return Le minimum.
     */
    public int min() {
        int min = nombres.get(0);
        for (int el : nombres)
            if (el <= min)
                min = el;
        return min;
    }

    /**
     * Trouve la valeur maximum de la liste.
     *
     * @return Le maximum.
     */
    public int max() {
        int max = nombres.get(0);
        for (int el : nombres)
            if (el >= max)
                max = el;
        return max;
    }

    /**
     * Enlève les extrema de la liste. S'il y a plusieurs minima ou maxima
     * ils sont tous enlevés.
     */
    public void removeMinAndMax() {
        Integer max = max();
        Integer min = min();
        while (nombres.indexOf(max) > 0) {
            nombres.remove(max);
        }
        while (nombres.indexOf(min) > 0) {
            nombres.remove(min);
        }
    }

    public void removeDuplicates() {
        for (int i = 0; i < nombres.size() -1; i++) {
            int currElem = nombres.get(i);
            int nextElem = nombres.get(i+1);
            if (currElem == nextElem) {
                nombres.remove(i);
                i--; // Takes n-replicates into account
            }
        }
    }

    @Override
    public String toString() {
        return "" + nombres;
    }

        public static void main (String[]args){
            Nombres nbr = new Nombres();
            nbr.add(1);
            nbr.add(3);
            nbr.add(3);
            nbr.add(7);
            nbr.add(8);
            nbr.add(8);
            nbr.add(8);
            nbr.removeDuplicates();
            System.out.println(nbr);
            }
        }
