package g55803.dev2.td4;

import g55803.dev2.td2.Moment;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Nathan Furnal
 */
public class TdListes {

    /** Somme tous les éléments d'une liste.
     * @param list Liste d'entiers.
     * @return La somme des éléments de la liste.
     */
    public static int sum(List<Integer> list){
        int sum = 0;
        for (int elt : list)
            sum += elt;
        return sum;
    }

    /** Supprime les doublons d'une liste triée.
     * @param list Une liste triée.
     */
    public static List<Integer> supprimerDoublon(List<Integer> list){
        int n = list.size();
        List <Integer> out = new ArrayList<>();
        out.add(list.get(0));
        for (int i = 1; i < n; i++) {
            int pastElem = list.get(i - 1);
            int currElem = list.get(i);
            if (pastElem != currElem){
                out.add(currElem);
            }
        }
        return out;
    }

    /** Fusionne deux listes triées en une seule liste triée sans les modifier.
     * @param l1 Première liste triée.
     * @param l2 Seconde liste triée.
     * @return Une troisième liste triée qui est la fusion des deux autres.
     * @see <a href= "https://stackoverflow.com/a/43194493/9479128">Stackoverflow answer</a>
     */
    public static List<Integer> mergeLists(List<Integer> l1, List<Integer> l2) {
        int outSize = l1.size() + l2.size();
        List<Integer> out = new ArrayList<>(outSize);
        int j = 0, k = 0;
        for (int i = 0; i < outSize; i++) {
            if(j == l1.size()){
                out.add(l2.get(k++));
            }
            else if (k == l2.size()){
                out.add(l1.get(j++));
            }
            else if (l1.get(j).compareTo(l2.get(k)) < 0){
                out.add(l1.get(j++));
            }
            else {out.add(l2.get(k++));}
        }
        return out;
    }

    public static Moment earliestMoment(Moment[] moments){
        Moment min = moments[0];
        for(Moment m : moments){
            if(min.compareTo(m) > 0){
                min = m;
            }
        }
        return min;
    }
    public static void main(String[] args) {
        var l1 = List.of(1, 3, 7, 7);
        var l2 = List.of(3, 9);
        var out = mergeLists(l1, l2);
        System.out.println(out);
        Moment[] momts = {new Moment(1, 2, 3), new Moment(0, 1, 1), new Moment(4, 5, 32)};
        Moment early = earliestMoment(momts);
        System.out.println(early);
    }
}

