package g55803.dev2.td5;

/**
 * @author Nathan Furnal
 */
public class Tableau2D {
    /** Affiche un tableau ligne par ligne.
     * @param tab Tableau à afficher.
     */
    public static void afficher(int[][] tab){
        for(int[] arr : tab){
            System.out.println();
            for(int el : arr){
                System.out.print(el + " ");
            }
        }
    }

    /** Calcule la proportion de valeurs nulles dans un
     * tableau à deux dimensions.
     * @param tab Un tableau à deux dimensions.
     * @return La proportion de valeurs nulles.
     */
    public static double proportionNuls(int[][] tab){
        int count = 0;
        int total = tab.length * tab[0].length;
        for(int[] arr : tab){
            for(int el : arr){
                if(el == 0){
                    count++;
                }
            }
        }
        return (double) count/total;
    }

    /** Vérifie si toutes les valeurs d'un tableau 2D sont strictements positives.
     * @param tab Un tableau à deux dimensions.
     * @return Vrai si toutes les valeurs sont strictement positives et faux autrement.
     */
    public static boolean tousPositifs(int[][] tab){
        for(int[] arr : tab){
            for(int el : arr){
                if(el <= 0){
                    return false;
                }
            }
        }
        return true;
    }

    public static int[][] swapRows(int[][] tab, int row1, int row2){
        int[] r = tab[row1];
        tab[row1] = tab[row2];
        tab[row2] = r;
        return tab;
    }

    public static int[][] makeTriangle(int n){
        int[][] arr = new int[n+1][];

        for(int i = 0; i <= n; i++){
            arr[i] = new int[i+1];
            for (int j = 0; j <=i; j++) {
                int topRow = i - 1;
                int leftCol = j - 1;
                if(topRow < 0 || leftCol < 0 || i == j){
                    arr[i][j] = 1;
                }
                else {
                    arr[i][j] = arr[topRow][j] + arr[topRow][leftCol];
                }
            }
        }
        return arr;
    }

    public static void showArray(int[][] tab){
        for(int[] arr : tab){
            System.out.println();
            for(int el : arr){
                System.out.printf("%2d", el);
                System.out.print(" ");
            }
        }
    }
}
