package g55803.dev2.td7.figure;


/**
 * @author Nathan Furnal
 */
public class Rectangle extends Figure{
    protected final double length;
    protected final double width;

    Rectangle(double len, double wid){
        this.length = len;
        this.width = wid;
    }

    public double getLength() {
        return length;
    }

    public double getWidth() {
        return width;
    }

    @Override
    public double getArea(){
        return getLength() * getWidth();
    }

//    @Override
//    public boolean equals(Object o) {
//        if (this == o) return true;
//        if (o == null) return false;
//
//        Rectangle rectangle = (Rectangle) o;
//
//        if (Double.compare(rectangle.getLength(), getLength()) != 0) return false;
//        return Double.compare(rectangle.getWidth(), getWidth()) == 0;
//    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || this.getClass() != o.getClass()) return false;

        Rectangle rectangle = (Rectangle) o;

        if (Double.compare(rectangle.getLength(), getLength()) != 0) return false;
        return Double.compare(rectangle.getWidth(), getWidth()) == 0;
    }

    @Override
    public int hashCode() {
        int result;
        long temp;
        temp = Double.doubleToLongBits(getLength());
        result = (int) (temp ^ (temp >>> 32));
        temp = Double.doubleToLongBits(getWidth());
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        return result;
    }
}
