package g55803.dev2.td7.jeu;

import java.util.Objects;

/**
 * @author Nathan Furnal
 */
public class Personnage {
    private String name;
    private int hp;
    private boolean drunk;
    private boolean invisible;

    public Personnage(String name) {
        this.name = name;
        this.hp = 40;
        this.drunk = false;
        this.invisible = false;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getHp() {
        return hp;
    }

    public void setHp(int hp) {
        this.hp = hp;
    }

    public boolean isDrunk() {
        return drunk;
    }

    public void setDrunk(boolean drunk) {
        this.drunk = drunk;
    }

    public boolean isInvisible() {
        return invisible;
    }

    public void setInvisible(boolean invisible) {
        this.invisible = invisible;
    }

    // L'annotation Override permet d'informer le compileur qu'on réécrit une méthode de la classe parent, ce qui permet
    // d'informer le compileur correctement en cas d'erreur de nom ou de signature.
    @Override
    public String toString() {
        return "Personnage{" +
                "name='" + name + '\'' +
                ", hp=" + hp +
                ", drunk=" + drunk +
                ", invisible=" + invisible +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Personnage that = (Personnage) o;

        if (getHp() != that.getHp()) return false;
        if (isDrunk() != that.isDrunk()) return false;
        if (isInvisible() != that.isInvisible()) return false;
        return getName() != null ? getName().equals(that.getName()) : that.getName() == null;
    }

    @Override
    public int hashCode() {
        return Objects.hash(getName(), getHp(), isDrunk(), isInvisible());
    }

    public static void main(String[] args) {
        Personnage[] personnages = {
                new Personnage("foo"),
                new Personnage("foo"),
                new Personnage("bar"),
        };
        for (Personnage p: personnages) {
            System.out.println(p.hashCode());
        }
    }
}
