package g55803.dev2.td1;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

/**
 * @author Nathan Furnal
 */
class MemoryTest {
    /**
     * Test du cas général de création de tableau Memory.
     */
    @Test
    void testInitCardsGeneralCase() {
        int n = 4;
        int[] expected = {1, 1, 2, 2, 3, 3, 4, 4};
        int[] actual = Memory.initCards(n);
        assertArrayEquals(expected, actual);
    }

    /**
     * Test du cas minimum n=3 de création du tableau Memory.
     */
    @Test
    void testInitCardsMinSize(){
        int n = 3;
        int[] expected = {1, 1, 2, 2, 3, 3};
        int[] actual = Memory.initCards(n);
        assertArrayEquals(expected, actual);
    }

    /**
     * Test du cas maximal n=20 de création du tableau Memory.
     */
    @Test
    void testInitCardsMaxSize(){
        int n = 20;
        int[] expected = {1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10,
        11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20};
        int[] actual = Memory.initCards(n);
        assertArrayEquals(expected, actual);
    }

    /**
     * Test de cas d'erreur avec valeur trop petite n = 2
     * de création du tableau Memory.
     */
    @Test
    void testInitCardsTooSmall(){
        int n = 2;
        assertThrows(IllegalArgumentException.class, () -> {
            Memory.initCards(n);
        });
    }

    /**
     * Test de cas d'erreur avec valeur trop grande n = 21
     * de création du tableau Memory.
     */
    @Test
    void testInitCardsTooBig(){
        int n = 21;
        assertThrows(IllegalArgumentException.class, () -> {
            Memory.initCards(n);
        });
    }
}