package g55803.dev2.td2;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

/**
 * @author Nathan Furnal
 */
class MomentTest {

    @Test
    public void testNegativeSeconds(){
        int sec = -10;
        assertThrows(IllegalArgumentException.class, () -> new Moment(1,1, sec));
    }

    @Test
    public void testSecondsTooLarge(){
        int sec = 60;
        assertThrows(IllegalArgumentException.class, () -> new Moment(1, 1, sec));
    }

    @Test
    public void testNegativeMinutes(){
        int min = -5;
        assertThrows(IllegalArgumentException.class, () -> new Moment(10, min, 10));
    }

    @Test
    public void testMinutesTooLarge(){
        int min = 60;
        assertThrows(IllegalArgumentException.class, () -> new Moment(1, min, 1));
    }

    @Test
    public void testNegativeHours(){
        int hour = -1;
        assertThrows(IllegalArgumentException.class, () -> new Moment(hour, 10, 10));
    }

    @Test
    public void testHoursTooLarge(){
        int hour = 24;
        assertThrows(IllegalArgumentException.class, () -> new Moment(hour, 1, 1));
    }

    @Test
    public void testCornerCasesAllZeros(){
        int sec = 0; int min = 0; int hour = 0;
        Moment m = new Moment(sec, min, hour);
        int[] expected = {0, 0, 0};
        assertArrayEquals(expected, new int[]{m.getHour(), m.getMinute(), m.getSecond()});
    }

    @Test
    public void testGetSecond(){
        int expected = 11;
        Moment m = new Moment(1, 2, 11);
        assertEquals(expected, m.getSecond());
    }

    @Test
    public void testGetMinute(){
        int expected = 11;
        Moment m = new Moment(0, 11, 3);
        assertEquals(expected, m.getMinute());
    }

    @Test
    public void testGetHour(){
        int expected = 11;
        Moment m = new Moment(11, 2, 2);
        assertEquals(expected, m.getHour());
    }

    @Test
    public void testEqualsNull(){
        Moment m = new Moment(1, 2, 3);
        assertNotEquals(m, null);
    }

    @Test
    public void testEqualsSameMoments(){
        Moment m = new Moment(10, 10, 10);
        assertEquals(m, m);
    }

    @Test
    public void testEqualsDifferentMomentsDifferentValues(){
        Moment m1 = new Moment(1, 2, 3);
        Moment m2 = new Moment(3, 4, 5);
        assertNotEquals(m1, m2);
    }

    @Test
    public void testEqualsDifferentMomentsSameValues(){
        Moment m1 = new Moment(11, 33, 44);
        Moment m2 = new Moment(11, 33, 44);
        assertEquals(m1, m2);
    }

    @Test
    public void testCompareToEqual(){
        Moment m1 = new Moment(1, 2, 3);
        Moment m2 = new Moment(1, 2, 3);
        int expected = 0;
        assertEquals(expected, m1.compareTo(m2));
    }

    @Test
    public void testCompareToLessThan(){
        Moment m1 = new Moment(11, 22, 30);
        Moment m2 = new Moment(14, 10, 5);
        int expected = -1;
        assertEquals(expected, m1.compareTo(m2));
    }

    @Test
    public void testCompareToGreaterThan(){
        Moment m1 = new Moment(22, 34, 10);
        Moment m2 = new Moment(11, 11, 11);
        int expected = 1;
        assertEquals(expected, m1.compareTo(m2));
    }
}