package g55803.dev2.td3;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

/**
 * @author Nathan Furnal
 */
class CardTest {

    @Test
    void testReveal() {
        Card c = new Card(10);
        c.reveal();
        assertFalse(c.isHidden());
    }

    @Test
    void testToStringHidden() {
        Card c = new Card(11);
        assertEquals("?", c.toString());
    }

    @Test
    void testToStringNotHidden(){
        Card c = new Card(12, false);
        assertEquals("12", c.toString());
    }

    @Test
    void testEqualsSameObj() {
        Card c  = new Card(11);
        assertEquals(c, c);
    }

    @Test
    void testEqualsDifferentObjectsSameValues(){
        Card c1 = new Card(11);
        Card c2 = new Card(11);
        assertEquals(c1, c2);
    }

    @Test
    void testEqualsNotEquals(){
        Card c1 = new Card(10);
        Card c2 = new Card(3);
        assertNotEquals(c1, c2);
    }

    @Test
    void testHashCode() {
        Card c = new Card(10);
        int hashTest = 73;
        hashTest = hashTest * c.getValue() + 11;
        assertEquals(hashTest, c.hashCode());
    }
}