package g55803.dev2.td5;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

/**
 * @author Nathan Furnal
 */
class Tableau2DTest {

    @Test
    public void testProportionsNulsNoZeros(){
        double expected = 0.0;
        int[][] tab = {{1, 2, 4,}, {2, 1, 3}, {1, 1, 1}};
        double actual = Tableau2D.proportionNuls(tab);
        assertEquals(expected, actual, 1e-6);
    }

    @Test
    public void testProportionsNulsAllZeros(){
        double expected = 1.0;
        int[][] tab = {{0, 0, 0}, {0, 0, 0}};
        double actual = Tableau2D.proportionNuls(tab);
        assertEquals(expected, actual, 1e-6);
    }

    @Test
    public void testProportionNulsRandomValues(){
        double expected = (double) 1/3;
        int[][] tab = {{1, 2, 0}, {0, 1, 2}, {3, 1, 0}};
        double actual = Tableau2D.proportionNuls(tab);
        assertEquals(expected, actual, 1e-6);
    }

    @Test
    public void testTousPositifs(){
        int[][] tab = {{1, 3, 4}, {3, 9, 7}, {1, 3, 7}};
        assertTrue(Tableau2D.tousPositifs(tab));
    }
    @Test
    public void testTousPositifsWithZeros(){
        int[][] tab = {{1, 3, 4}, {3, 9, 7}, {1, 0, 7}};
        assertFalse(Tableau2D.tousPositifs(tab));
    }

    @Test
    public void testTousPositifsWithNegatives(){
        int[][] tab = {{1, 3, 4}, {3, -9, 7}, {1, -1, 7}};
        assertFalse(Tableau2D.tousPositifs(tab));
    }

}